
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【案例】利用innodb_force_recovery 解决MySQL服务器crash无法重启问题 / iVAN</title>

    <meta name="description" content="【案例】利用innodb_force_recovery 解决MySQL服务器crash无法重启问题 一 背景    某一创业的朋友的主机因为磁盘阵列损坏机器crash,重启MySQL服务时 报如下错误: InnoDB: Reading tablespace information from the .ibd files... InnoDB: Restoring possible half-written data pages from the doublewrite InnoDB: buffer... InnoDB: Doing recovery: scanned up to log sequ">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">【案例】利用innodb_force_recovery 解决MySQL服务器crash无法重启问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>一 背景</strong></p>
<p>   某一创业的朋友的主机因为磁盘阵列损坏机器crash,重启MySQL服务时 报如下错误:</p>
<pre><code>InnoDB: Reading tablespace information from the .ibd files...

InnoDB: Restoring possible half-written data pages from the doublewrite

InnoDB: buffer...

InnoDB: Doing recovery: scanned up to log sequence number 9120034833

150125 16:12:51 InnoDB: Starting an apply batch of log records to the database...

InnoDB: Progress in percents: 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 150125 16:12:51 [ERROR] mysqld got signal 11 ;

This could be because you hit a bug. It is also possible that this binary

or one of the libraries it was linked against is corrupt, improperly built,

or misconfigured. This error can also be caused by malfunctioning hardware.

To report this bug, see http://kb.askmonty.org/en/reporting-bugs

We will try our best to scrape up some info that will hopefully help

diagnose the problem, but since we have already crashed, 

something is definitely wrong and this may fail.

Server version: 5.5.37-MariaDB-log

key_buffer_size=268435456

read_buffer_size=1048576

max_used_connections=0

max_threads=1002

thread_count=0

It is possible that mysqld could use up to 

key_buffer_size + (read_buffer_size + sort_buffer_size)*max_threads = 2332093 K bytes of memory

41 Hope that.
</code></pre>
<p><strong>二 分析</strong><br />
    主要关注 mysqld got signal 11 的问题,从日志内容分析来看,数据库在机器crash 导致日志文件损坏,重启之后无法正常恢复,更无法正常对外提供服务。</p>
<p><strong>三 解决</strong><br />
    因为日志已经损坏，这里采用非常规手段,首先修改innodb_force_recovery参数，使mysqld跳过恢复步骤，将mysqld 启动,将数据导出来然后重建数据库。<br />
innodb_force_recovery可以设置为1-6,大的数字包含前面所有数字的影响。<br />
  1. (SRV_FORCE_IGNORE_CORRUPT):忽略检查到的corrupt页。<br />
  2. (SRV_FORCE_NO_BACKGROUND):阻止主线程的运行，如主线程需要执行full purge操作，会导致crash。<br />
  3. (SRV_FORCE_NO_TRX_UNDO):不执行事务回滚操作。<br />
  4. (SRV_FORCE_NO_IBUF_MERGE):不执行插入缓冲的合并操作。<br />
  5. (SRV_FORCE_NO_UNDO_LOG_SCAN):不查看重做日志，InnoDB存储引擎会将未提交的事务视为已提交。<br />
  6. (SRV_FORCE_NO_LOG_REDO):不执行前滚的操作。<br /><strong><u>注意 </u></strong><br /><strong><u>   a 当设置参数值大于0后，可以对表进行select,create,drop操作,但insert,update或者delete这类操作是不允许的。</u></strong><br /><strong><u>  b 当innodb_purge_threads 和 innodb_force_recovery一起设置会出现一种loop现象:  </u></strong> </p>
<pre><code>150125 17:07:42 InnoDB: Waiting for the background threads to start

150125 17:07:43 InnoDB: Waiting for the background threads to start

150125 17:07:44 InnoDB: Waiting for the background threads to start

150125 17:07:45 InnoDB: Waiting for the background threads to start

150125 17:07:46 InnoDB: Waiting for the background threads to start

150125 17:07:47 InnoDB: Waiting for the background threads to start
</code></pre>
<p>在my.cnf中修改以下两个参数<br /><strong><u>innodb_force_recovery=6</u></strong><br /><strong><u> innodb_purge_thread=0</u></strong></p>
<p>重启MySQL </p>
<pre><code>150125 17:10:47 [Note] Crash recovery finished.

150125 17:10:47 [Note] Server socket created on IP: '0.0.0.0'.

150125 17:10:47 [Note] Event Scheduler: Loaded 0 events

150125 17:10:47 [Note] /vdata/webserver/mysql/bin/mysqld: ready for connections.

Version: '5.5.37-MariaDB-log' socket: '/tmp/mysql.sock' port: 3306 Source distribution
</code></pre>
<p>立即对数据库做逻辑导出 ，完成之后将innodb_force_recovery设置为0 ，innodb_purge_thread=1 ,然后重建数据库 。<br />
另外 MySQL 版本 5.5以及之前 ,当innodb_purge_threads =1，innodb_force_recovery &gt;1 的情况会出现上文提到的循环报warning 问题（=1 没有问题），<br />
原因：<br />
MySQL 的源代码中显示  当innodb_purge_threads 和 innodb_force_recovery一起设置会出现loop循环</p>
<pre><code>while (srv_shutdown_state == SRV_SHUTDOWN_NONE) { 

      if (srv_thread_has_reserved_slot(SRV_MASTER) == ULINT_UNDEFINED 

          || (srv_n_purge_threads == 1 

          &amp;&amp; srv_thread_has_reserved_slot(SRV_WORKER) 

          == ULINT_UNDEFINED)) { 

          ut_print_timestamp(stderr); 

          fprintf(stderr, " InnoDB: Waiting for the background threads to start\n");
          os_thread_sleep(1000000); 

      } else { 

          break; 

      } 

  }
</code></pre>
<p>所以当需要设置innodb_force_recovery&gt;1的时候需要关闭 innodb_purge_threads，设置为0（默认）。</p>
<p><strong>四 小结</strong> <br />
   MySQL crash 或者 MySQL 数据库服务器 crash 会导致各种各样的问题 ，比如主备之间的<a href="http://blog.itpub.net/22664653/viewspace-759567/" rel="external nofollow noreferrer"><strong>error </strong><strong>1594</strong></a> (5.6 版本开启<a href="http://www.percona.com/blog/2013/09/13/enabling-crash-safe-slaves-with-mysql-5-6/" rel="external nofollow noreferrer"><strong>crash-safe</strong></a> ，会最大程度上避免 error 1594的问题，以后会写5.6新特性介绍该功能 )，<strong><a href="http://blog.itpub.net/22664653/viewspace-732503/" rel="external nofollow noreferrer">error </a></strong><strong><a href="http://blog.itpub.net/22664653/viewspace-732503/" rel="external nofollow noreferrer">1236</a>，</strong><strong> 日志损坏</strong>，<strong>数据文件损坏</strong> ，等等，本案例只是其中的一种，细心从日志中找的相关错误提示，逐步解决即可。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 21:32:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%95%b0%e6%8d%ae%e5%ba%93rds/" title="云数据库RDS">云数据库RDS</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>【案例】利用innodb_force_recovery 解决MySQL服务器crash无法重启问题的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmrkLz.html" rel="bookmark">matlab-Matlab程序案例利用Matlab解决一个利用最优化原理的实际问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Matlab程序案例利用Matlab解决一个利用最优化原理的实际问题 能不能给出一个利用最优化方法工具是使用Matlab来实现的具体案例? 解决方案 听起来是算法表示不懂--话说算法好牛的大数学家的算法可以根据你随便给定的几个数字推算出一个数列符合要求-- 解决方案二: http://cn.mathworks.com/products/optimization/?requestedDomain=www.mathworks.com看官方文档. 解决方案三: 用最小堆解决一个实际问题			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvQGPM.html" rel="bookmark">使用innodb&lowbar;force&lowbar;recovery解决MySQL崩溃无法重启问题&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一 背景 某一创业的朋友的主机因为磁盘阵列损坏机器crash,重启MySQL服务时 报如下错误: 复制代码 代码如下: InnoDB: Reading tablespace information from the .ibd files... InnoDB: Restoring possible half-written data pages from the doublewrite InnoDB: buffer... InnoDB: Doing recovery: scanned up to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKgy8z.html" rel="bookmark">解决Mysql服务器启动时报错问题的方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 文章主要介绍因为启动mysql服务报错引发的问题:&quot;ERROR! The server quit without updating PID file (/var/lib/mysql/localhost.localdomain.pid)&quot;,顺带扩充一些其它的知识点,当前版本是red hat 6,mysql 5.6. 二.步骤 报错的源头 问题解决 1.权限 报错的源头就是它了,一般这种问题首先会想到的就是权限问题,就是/var/lib/mysql该文件夹的权限 上图可以看到my			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKEl1p.html" rel="bookmark">如何在Centos 6&period;3下利用rsyslog&plus;loganalyzer&plus;mysql部署日志服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作为一名系统运维工程师,平时查看分析LINUX系统日志我觉得是我们每天必做的功课,但时间长了会发现每次查看站点日志都得挨个进后台,几台服务器还可以这么对付,但如果管理成百上千台线上服务器,这种方法就捉襟见肘了. 后来想了想能不能有一台日志服务器集中管理日志,并以WEB形式将日志显示到前台方便查看,顿时码字的想法油然而生,呵呵. 本人有一个习惯,那就是会把群里或者网上看到的圈内比较认可的LINUX系统软件先保存在备忘录,等闲下来研究研究,刚好前段时间有位朋友提到rsyslog+loganalyze			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmxwVp.html" rel="bookmark">解决 phpmyadmin &num;2002 无法登录 MySQL 服务器&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				解决 .#2002 无法登录 MySQL 服务器 将config.sample.inc.php复制成config.inc.php 出现这个错误,表示没有连接到数据库.修改config.inc.php文件, 复制代码 代码如下: 将$cfg['Servers'][$i]['host'] = 'localhost'; 改为$cfg['Servers'][$i]['host'] = '127.0.0.1'; 或者 修改 php.ini : mysql.default_socket = /tmp/mys			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYe0Lb.html" rel="bookmark">MySQL服务器进程CPU占用100&percnt;的解决方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				朋友主机(Windows 2003 + IIS + PHP + MYSQL )近来 MySQL 服务进程 (mysqld-nt.exe) CPU 占用率总为 100% 高居不下.此主机有10个左右的 database, 分别给十个网站调用.据朋友测试,导致 mysqld-nt.exe cpu 占用奇高的是网站A,一旦在 IIS 中将此网站停止服务,CPU 占用就降下来了.一启用,则马上上升. MYSQL CPU 占用 100% 的解决过程 今天早上仔细检查了一下.目前此网站的七日平均日 IP 为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MryBVmb.html" rel="bookmark">解决登陆phpMyAdmin出现&rdquo;&num;2002 无法登录 MySQL 服务器&rdquo;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般情况下,我们在管理Linux VPS服务器网站数据库的时候,大部分会使用PHPMYADMIN面板可视化管理数据库.晚上一网友告知原本可以登录的PHPMYADMIN今天无法登陆,但是网站运营都正常的,登录PHPMYADMIN的时候有出现红色&quot;#2002 无法登录 MySQL 服务器&quot;的错误提示,确定密码和用户是没有问题的.     出现问题不要紧,我们去寻找和搜索解决方法,最为直接的方法如下:   第一.遍历到我们当前网站环境中PHPMYADMIN文件夹所在的目录   第二.找到co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvaxNb.html" rel="bookmark">优化MYSQL服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|服务器|优化    MySQL服务器有几个影响其操作的参数(变量).如果缺省的参数值不合适,可以将其修改为对服务器运行环境更合适的值.例如,如果您有大量的内存,可以告诉服务为磁盘和索引操作使用较大的缓冲区.这将使内存持有更多的信息并减少了必须进行的磁盘访问的数量.如果是一般的系统,可以告诉服务器使用较小的缓冲区,以防止它扰乱系统资源损害其他的进程.    系统变量的当前值可以通过执行mysqladmin variables 命令来检查.变量可利用- - set - variable			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqqnap.html" rel="bookmark">MySQL服务器默认安装之后调节性能的方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				My favorite question during Interview for people to work as MySQL DBAs or be involved with MySQL Performance in some way is to ask them what should be tuned in MySQL Server straight after installation, assuming it was installed with default settings.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5eDpn.html" rel="bookmark" class="title">IE设置通过新选项卡打开链接</a>
					<div>
						  IE7和IE8都提供了选项卡浏览网页的功能,但是单击网页中的链接时,仍然打开新的窗口. 在IE7和IE8中可以通过多个选项卡浏览新的网页,但默认的设置是通过新窗口打开连接,如果需要在新选项卡中打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLdNZp.html" rel="bookmark" class="title">DHTML实现可控制的页面内滚动区域</a>
					<div>
						dhtml|控制|页面 首先,我们在样式表里加入&quot;.opacity {FILTER: alpha(opacity=100)&quot;,看下面! &lt;style type=&quot;t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLooLM.html" rel="bookmark" class="title">使用PHP 5&period;0 轻松解析XML文档（2）</a>
					<div>
						xml 文件:SimpleDocumentParser.php &lt;?php/** *======================================================= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvDJ6z.html" rel="bookmark" class="title">在 PHP 中用描点法&OpenCurlyDoubleQuote;绘制&rdquo;中文</a>
					<div>
						中文 作者:LuciferStar 来源:超越PHP 前言:现在,越来越多的人喜欢上网了,越来越多的人拥有了自己的个人主页.随着各种自动化软件工具的出现,制作网页越来越简单.但,由于特效随处可得,创新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLAWkb.html" rel="bookmark" class="title">xen server 存储库&lpar;sr&rpar;损坏的数据恢复方案</a>
					<div>
						[常见故障] 一.sr无法识别,所有虚拟磁盘(vdi)丢失 二.sr中的虚拟磁盘(vdi)访问时报错 三.虚拟磁盘(vdi)删除或丢失 四.快照(snapshot)删除或丢失 五.sr初始化 六.sr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6BLdz.html" rel="bookmark" class="title">实现&OpenCurlyDoubleQuote;自动化&rdquo;的WPS素材库</a>
					<div>
						记得某个电影中有句经典台词&quot;二十一世纪什么最重要--人才&quot;,在我们使用办公软件时什么最重要?那当然是素材了.WPS2012把素材库的功能更加&quot;自动化&quot;了. 单击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62RmoM.html" rel="bookmark" class="title">鲁大师漏洞修复无效的解决方案</a>
					<div>
						KB955535修复无效的解决方案 对于一些整合光盘系统无法修复KB955535补丁,原因是出在整合安装光盘去掉了KB957097的安装信息,故导致KB955355不能正常安装. 解决办法:首先去Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M916EdM.html" rel="bookmark" class="title">怎么设置Word的箭头样式</a>
					<div>
						我们在使用word文档编辑时,时常会用到各种箭头,本教程就为大家介绍一下怎么设置箭头样式. 电脑教程 Word中设置箭头样式 以Microsoft Word 2010软件为例介绍Word中设置箭头样式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLXLab.html" rel="bookmark" class="title">如何在Word文档中添加删除个人信息</a>
					<div>
						在Word的文档编辑中,我们可以用Word的域功能来轻松地完成自己的个人资料,如姓名.单位.邮编.地址等的输入. 方法如下: 1.单击[工具]栏中的[选项]命令,打开[选项]对话框,选择[用户信息]选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArX8Xp.html" rel="bookmark" class="title">删除Win8用户账户的小妙招</a>
					<div>
						  删除Win8用户账户操作步骤如下: 1.[开始菜单][运行],然后输入[lusrmgr.msc]并按回车. 2.出现本地用户和组的窗口,在左侧面板的用户上点击鼠标右键. 3.找到你建立的帐户名,, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa1KxM.html" rel="bookmark" class="title">新浪微博分组怎么删除</a>
					<div>
						  1.登录新浪微博账号,点击自己关注的人,如图 2.点击后最右侧会出现分组的栏目,选择自己想要删除的分组点击进入,小编是以同事分组为例点击进入 3.进入后,右上方会出现删除分组这个选项,点击删除分组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72Kj5p.html" rel="bookmark" class="title">天涯共此双11&mdash;&mdash;天猫升级港澳台&OpenCurlyDoubleQuote;购物天堂&rdquo;</a>
					<div>
						香港北区上水60多年的老字号正和隆酱油没想过会出名.这家专注服务街坊的小店不在乎&quot;酱香巷子深&quot;,门店一半是透明及地的塑胶门帘,一半是一块块拼接起来的黄色纸板箱. 来的都是熟客,所谓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQmV5z.html" rel="bookmark" class="title">jsp java mysql-基于jsp的网上书店系统代码调试</a>
					<div>
						问题描述 基于jsp的网上书店系统代码调试 从网上下载了一个网上书店系统的代码,导入到myeclipse中好多错误,数据库用的是mysql,我只学了一点点jsp的内容,自己不会调,这个系统我急着用,谁 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNEBkz.html" rel="bookmark" class="title">即构ZEGO创始人兼CEO林友尧：闯进原始森林</a>
					<div>
						从大学毕业进入腾讯十三年,一直做到QQ总经理,虽然在腾讯这棵大树下取得了成绩,但林友尧想去原始森林里闯一闯.2015年创立即构科技,林友尧开启了人生的第二段旅程.2017年8月初,LiveVideoS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mydyw8b.html" rel="bookmark" class="title">在 Centos&sol;RHEL 6&period;X 上安装 Wetty</a>
					<div>
						在 Centos/RHEL 6.X 上安装 Wetty Wetty 是什么? Wetty = Web + tty 作为系统管理员,如果你是在 Linux 桌面下,你可以用它像一个 GNOME 终端(或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY44Op.html" rel="bookmark" class="title">Android中文API （39） &mdash;&mdash; AbsSpinner</a>
					<div>
						前言 本章内容是 android.widget.AbsSpinner,版本为Android 2.2 r1,翻译来自&quot;思考的狼&quot;,欢迎大家访问他的博客:http://blog.163 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5DGZM.html" rel="bookmark" class="title">站长分享：如何识别友情链接骗术</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 有丰富的外链每个站长所期望的,&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd1xEb.html" rel="bookmark" class="title">手机实名制还有多少个关卡要过</a>
					<div>
						手机实名制还有多少个关卡要过 &quot;你总说,垃圾短信.诈骗短信.黄色信息横行都是没有实名制惹的祸,其实让人很困惑.&quot;当新年假期上班几日后,得知工信部部长李毅中表示&quot;目前相关部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydGdlb.html" rel="bookmark" class="title">求C&num;高手</a>
					<div>
						问题描述 在局域网里,,.怎么实现在后台添加附件,在前台下载.....想好久了,希望各位前辈可以帮帮忙,谢谢了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAJmvM.html" rel="bookmark" class="title">写给初学者的Linux压缩教程</a>
					<div>
						Linux的压缩命令的源文件只能有一个,这意味在压缩之前不得不先将要压缩的所有文件打包成一个包,然后再压缩包,这样来完成对多个文件的压缩.所以在了解解压缩之前就必须先了解打包命令. Linux的打包一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjZWNM.html" rel="bookmark" class="title">苹果分级制形同虚设免费图书前20名4本涉黄</a>
					<div>
						本报实习记者 吴迪 卢女士的孩子今年十七周岁,九月刚上大一.开学前,卢女士给孩子买了一部iPhone4手机.前两天,卢女士登录iTunes客户端,想看看孩子苹果手机里到底有啥新鲜玩意儿.她点开热门软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkN7ZM.html" rel="bookmark" class="title">Disruptor入门</a>
					<div>
						获得Disruptor 可以通过Maven或者下载jar来安装Disruptor.只要把对应的jar放在Java classpath就可以了. 基本的事件生产和消费 我们从一个简单的例子开始学习Dis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xjrXb.html" rel="bookmark" class="title">优酷土豆合并后还需面对的几项风险</a>
					<div>
						向外界解释合并原因.走向和给予信心显然不是件容易的事情.优酷网CEO古永锵和土豆网CEO王微于昨日上午同时发布了同样内容的微博:&quot;一家公司,两个品牌,两个网站,两个销售体系,在合作.开放.尊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1wgab.html" rel="bookmark" class="title">美元登陆香港&quot;过桥&quot;资本净流入涌动热钱正卷土重来</a>
					<div>
						拿出超过200亿美金对冲热钱,香港金融监管局截至5月末的这个数据表明了一个重要事实:这是自2004年以来最大规模对冲来港热钱.而香港股市和房市双双齐涨,更使恒生地产分类指数自3月初以来上涨了54%.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj88jNp.html" rel="bookmark" class="title">php &dollar;&lowbar;SERVER&lbrack;&amp;&num;039&semi;HTTP&lowbar;USER&lowbar;AGENT&amp;&num;039&semi;&rsqb; 用法介绍</a>
					<div>
						1.用户访问服务器时,利用PHP的超级全局变量$_SERVER数组中字段['HTTP_USER_AGENT'] 获取访问用户的所有信息  代码如下 复制代码 &lt;?php  echo $_SERV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZZ0vb.html" rel="bookmark" class="title">十天学会php之第四天&lowbar;php基础</a>
					<div>
						  学习目的:学会连接数据库 PHP简直就是一个函数库,丰富的函数使PHP的某些地方相当简单.建议大家down一本PHP的函数手册,总用的到. 我这里就简单说一下连接MYSQL数据库. 1.mysql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QYXBp.html" rel="bookmark" class="title">jspsmart文件上传与邮件发送的实例&lowbar;JSP编程</a>
					<div>
						1.jspsmart文件上传(普通表单,带有普通表单域.若干个文件选择域) 页面: 复制代码 代码如下: &lt;form class=&quot;form-horizontal&quot; id=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEA7Az.html" rel="bookmark" class="title">JS图片切换的具体方法&lpar;带缩略图版&rpar;&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2nYOM.html" rel="bookmark" class="title">浅谈javascript中replace&lpar;&rpar;方法&lowbar;javascript技巧</a>
					<div>
						定义和用法 replace() 方法用于在字符串中用一些字符替换另一些字符,或替换一个与正则表达式匹配的子串.语法stringObject.replace(regexp/substr,replacem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7rkAM.html" rel="bookmark" class="title">PHP的serialize序列化数据与JSON格式化数据的例子</a>
					<div>
						PHP的serialize是将变量序列化,返回一个具有变量类型和结构的字符串表达式,而JSON则是一种更轻.更友好的用于接口(AJAX.REST等)数据交换的格式. 其实两者都是以一种字符串的方式来体 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
